<template>
  <q-page class="row justify-center content-start bg-blue-grey-1 q-pa-xl">
    <div class="row justify-between col-12 q-pb-lg">
      <div
        class="text-h4 text-bold text-primary self-end"
        v-text="'Vídeos'"
      />

      <q-btn
        class="super-rounded-borders"
        style="width: 272px"
        label="Novo Vídeo"
        color="primary"
        padding="14px"
        @click="edit()"
      />
    </div>

    <table-view
      class="col-12"
      :columns="columns"
      :table-data="tableData"
      :categories="categories"
      sort-by="id"
      @reload="asyncReload('tableData')"
    />
  </q-page>
</template>

<script>
import TableView from 'components/video/table-view'
import FormVideo from 'components/video/form-video'

const formFactory = JSON.stringify({
  title: '',
  categoryId: '',
  thumbnail: '',
  url: ''
})

export default {
  name: 'PageVideos',
  components: { TableView },
  asyncData: {
    tableDataDefault: [],
    async tableData () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/VideoLessons',
          params: {
            filter: {
              include: {
                relation: 'category',
                scope: {
                  fields: ['label']
                }
              }
            }
          }
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    },
    categoriesDefault: [],
    async categories () {
      this.$q.loading.show()

      try {
        const axiosConfig = {
          method: 'GET',
          url: '/Categories',
          params: {
            filter: {
              fields: ['id', 'label'],
              where: { type: 'video' }
            }
          }
        }

        return this.$axios(axiosConfig).then(R => R.data)
      } catch (err) {
        this.axiosCatch(err)

        return undefined
      } finally {
        this.$q.loading.hide()
      }
    }
  },
  data () {
    return {
      columns: [
        { name: 'id', field: 'id', label: '#', align: 'left', sortable: true },
        { name: 'title', field: 'title', label: 'Título', align: 'left', sortable: true },
        { name: 'category', field: 'category', label: 'Categoria', align: 'left', sortable: true, format: (val, row) => val ? val.label : row.categoryId },
        { name: 'thumbnail', field: 'thumbnail', label: 'Imagem', align: 'center' },
        { name: 'action', field: 'action', label: 'Ações', align: 'center' }
      ]
    }
  },
  methods: {
    edit (row = JSON.parse(formFactory)) {
      this.$q.dialog({
        component: FormVideo,
        value: Object.assign({}, row),
        options: this.categories,
        parent: this
      }).onOk(() => {
        this.asyncReload('tableData')
      })
    }
  }
}
</script>
